-- Include Encounter Files

-- Local Variables
local lastVoice = 0;
local firstCall = 0;

-- Helper Function to receive the remaining Time of a Debuff
local function getDebuffTime(tarUnit, abilityId)

  local result = 0;
  
  -- Loop through all Debuffs
  for i = 1,40 do
    local _, _, _, _, _, _, expirationTime, _, _, _, spellId = UnitDebuff(tarUnit, i); 
    
    -- Error Check. Nil Values should be handled
    if expirationTime ~= nil and spellId ~= nil then
      -- Target has the specific Debuff
      if spellId == abilityId then
        result = expirationTime - GetTime();  
      end
    end
  end
  
  -- Handle negative Numbers
  if result >= 0 then
    return result;
  else
    return 0;
  end
end

-- Plays a Sound every time the Player needs to taunt
function ursocHandle()
  -- Initialize
  if firstCall == 0 then
    lastVoice = GetTime();
    firstCall = 1;
    message(lastVoice);
  end
  
  -- Check whether the Player is tanking
  local isTanking, _, _, _, _ = UnitDetailedThreatSituation("player", "target");
  
  -- t1: Player, t2: Focus (Other Tank)
  -- Get Tank Debuffs
  local t1Overwhelm = getDebuffTime("player", 197943);
  local t2Overwhelm = getDebuffTime("focus" , 197943);
  local t1RendFlesh = getDebuffTime("player", 197942);
  local t2RendFlesh = getDebuffTime("focus" , 197942);
  
  -- Calculate maximal Debuff Time on each Tank
  local t1Max, t2Max;
  
  if t1Overwhelm > t1RendFlesh then
    t1Max = t1Overwhelm;
  else
    t1Max = t1RendFlesh;
  end
  
  if t2Overwhelm > t2RendFlesh then
    t2Max = t2Overwhelm;
  else
    t2Max = t2RendFlesh;
  end
  
  -- Voice only once per second
  if GetTime() - lastVoice >= 1 then 
    -- If the remaining Debuff Time of the Player is less the remaining Debuff Time of the other Tank, the Player needs to taunt
    if t1Max < t2Max and not isTanking then
      PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");
      lastVoice = GetTime();
    end
  end 
  
end


-- Create Frame handling Events
local ebonBladeRaidAssistFrame = CreateFrame("Frame");
ebonBladeRaidAssistFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
ebonBladeRaidAssistFrame:SetScript("OnEvent",
  function(self, event, ...)
    -- Check whether Player is in Raid
    local zoneName = GetRealZoneText();
  
    if zoneName == "The Emerald Nightmare" or zoneName == "Der Smaragdgrüne Alptraum" then    
      
      -- Select Encounter
      local tarName = UnitName("target");
      
      -- Ursoc
      if tarName == 'Ursoc' then
        ursocHandle();
      end
      
    end
  end
)