-- Read File Input
local function readFile(path)
  local file = open(path, "rb");
    
  if not file then
    return nil;
  end

  local content = file:read "*a";
  file:close();
  return content;
end


-- Translate German Names to English Names
local function translateName(bossName)
  -- The Emerald Nightmare
  if bossName == "Auge von Il'gynoth" or bossName == "Eye of Il'gynoth" then
    return 'Ilgynoth';
  else
    return bossName;
  end
end


-- Display Guide in Box
local function getGuide()

  -- TEST
  --local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceMapID, instanceGroupSize = GetInstanceInfo();
  --message(difficultyName);
  PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");
  message("Ton!");


  -- Check whether Player is in Raid
  local zoneName = GetRealZoneText();
  
  if zoneName == "The Emerald Nightmare" or zoneName == "Der Smaragdgrne Alptraum" then

    -- Only show outside of Combat
    if not UnitAffectingCombat("player") then

      -- Get Target Name
      local tarName = UnitName("target");

      -- Translate German Names to English Names
      tarName = translateName(tarName);

      -- Check whether there is a Guide for the Target
      --for dirRaid in io.popen([[dirRaid "." /b /ad]]):lines() do
      --  for dirEncounter in io.popen([[dirEncounter "./" .. dirRaid /b /ad]]):lines() do        
      --    if tarName == dirEncounter then
      --  
      --      -- Get Player Role
      --      local role = UnitGroupRolesAssigned("player");
      --
      --      -- Get Raid Difficulty
      --      --local ., ., ., difficultyName, ., ., ., ., . = GetInstanceInfo();
      --
      --      -- Determine Name if File which should be loaded ("./RaidName/EncounterName/[NHC|HC|MYTHIC]_[Tank|Heal|DD].txt")
      --      local filePath = './' .. zoneName .. '/' .. tarName .. '/';
      --
      --      filePath = filePath .. role;
      --
      --      local guide = readFile(filePath);
      --      message(guide);
      --
      --    end
      --  end
      --end
    end
  end
end


-- Create Frame handling Events
local ebonBladeRaidAssistFrame = CreateFrame("Frame");
ebonBladeRaidAssistFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
ebonBladeRaidAssistFrame:SetScript("OnEvent",
  function(self, event, ...)
    getGuide();
  end
)