-- Create Module for Encounter
Ursoc = {};

-- Helper Function to receive the remaining Time of a Debuff
local function getDebuffTime(tarUnit, spellID)
  local _, _, _, _, _, _, expirationTime = UnitDebuff(tarUnit, spellID);
  
  local result = expirationTime - GetTime();
  
  if result >= 0 then
    return result;
  else
    return 0;
  end
end

function Ursoc.handle()
  PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");

  -- t1: Player, t2: Focus (Other Tank)
  -- Get Tank Debuffs
  local t1Overwhelm = getDebuffTime("player", 197943);
  local t2Overwhelm = getDebuffTime("focus" , 197943);
  local t1RendFlesh = getDebuffTime("player", 197942);
  local t2RendFlesh = getDebuffTime("focus" , 197942);
  
  
  -- Calculate maximal Debuff Time on each Tank
  local t1Max, t2Max;
  
  if t1Overwhelm > t1RendFlesh then
    t1Max = t1Overwhelm;
  else
    t1Max = t1RendFlesh;
  end
  
  if t2Overwhelm > t2RendFlesh then
    t2Max = t2Overwhelm;
  else
    t2Max = t2RendFlesh;
  end
  
  
  -- If the Player does not have a Debuff but the other Tank does, the Player needs to taunt
  if t1Max == 0 and t2Max > 0 then
    PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");
  
  -- If the remaining Debuff Time of the Player is less the remaining Debuff Time of the other Tank, the Player needs to taunt
  elseif t1Max < t2Max then
    PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");
  end
end

return Ursoc;